using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MessenForSig3
{
	public class InputStatusForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox StatusTextBox;
		private System.Windows.Forms.Button OKButton;
		private System.Windows.Forms.CheckBox BusyCheckBox;
	
		public string msg;
		public bool busy;
		public InputStatusForm()
		{
			InitializeComponent();

			DialogResult = DialogResult.Cancel;
			msg = "";
			busy = false;
			StatusTextBox.Focus();
		}

		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.StatusTextBox = new System.Windows.Forms.TextBox();
			this.OKButton = new System.Windows.Forms.Button();
			this.BusyCheckBox = new System.Windows.Forms.CheckBox();
			// 
			// StatusTextBox
			// 
			this.StatusTextBox.Size = new System.Drawing.Size(208, 19);
			this.StatusTextBox.Text = "";
			// 
			// OKButton
			// 
			this.OKButton.Location = new System.Drawing.Point(160, 24);
			this.OKButton.Size = new System.Drawing.Size(48, 24);
			this.OKButton.Text = "OK";
			this.OKButton.Click += new System.EventHandler(this.OKButton_Click);
			// 
			// BusyCheckBox
			// 
			this.BusyCheckBox.Location = new System.Drawing.Point(0, 24);
			this.BusyCheckBox.Size = new System.Drawing.Size(152, 24);
			this.BusyCheckBox.Text = "Z";
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			// 
			// InputStatusForm
			// 
			this.ClientSize = new System.Drawing.Size(210, 49);
			this.Controls.Add(this.BusyCheckBox);
			this.Controls.Add(this.OKButton);
			this.Controls.Add(this.StatusTextBox);
			this.Text = "VԂ͂Ă";

		}
		#endregion

		private void OKButton_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.OK;
			msg = StatusTextBox.Text;
			busy = BusyCheckBox.Checked;
			Close();
		}

		public void SetUserStatus(string msg, bool away)
		{
			StatusTextBox.Text = msg;
			BusyCheckBox.Checked = away;
			StatusTextBox.Focus();
		}
	}
}
