using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.IO;
using YahooMessenger;

namespace MessenForSig3
{
	public class MainForm : System.Windows.Forms.Form, IYahooMessenger
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuLogin;
		private System.Windows.Forms.TreeView FriendsTreeView;
		private System.Windows.Forms.ContextMenu StatusChangeMenu;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItemAVAILABLE;
		private System.Windows.Forms.MenuItem menuItemBUSY;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem menuItemNOTATHOME;
		private System.Windows.Forms.MenuItem menuItemNOTINOFFICE;
		private System.Windows.Forms.MenuItem menuItemINVISIBLE;
		private System.Windows.Forms.MenuItem menuItemONPHONE;
		private System.Windows.Forms.MenuItem menuItemONVACATION;
		private System.Windows.Forms.MenuItem menuItemOUTTOLUNCH;
		private System.Windows.Forms.MenuItem menuItemSTEPPEDOUT;
		private System.Windows.Forms.MenuItem menuItemCUSTOM;
		private System.Windows.Forms.MenuItem menuItemBRB;
		private System.Windows.Forms.MenuItem menuSendIM;
		private System.Windows.Forms.MenuItem menuDisconnect;
		private System.Windows.Forms.MenuItem menuTerminate;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuChangeStatus;
		private System.Windows.Forms.MenuItem menuConfig;
		private System.Windows.Forms.MenuItem menuItem5;
		
		private MessageFormList list;
		private YahooProcess yp;
		private YahooData person;

		public MainForm()
		{
			InitializeComponent();

			list = new MessageFormList(this);
			this.FriendsTreeView.Click += new System.EventHandler(this.FriendsTreeView_Click);
		}

		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.StatusChangeMenu = new System.Windows.Forms.ContextMenu();
			this.menuItemAVAILABLE = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItemBRB = new System.Windows.Forms.MenuItem();
			this.menuItemBUSY = new System.Windows.Forms.MenuItem();
			this.menuItemNOTATHOME = new System.Windows.Forms.MenuItem();
			this.menuItemNOTINOFFICE = new System.Windows.Forms.MenuItem();
			this.menuItemONPHONE = new System.Windows.Forms.MenuItem();
			this.menuItemONVACATION = new System.Windows.Forms.MenuItem();
			this.menuItemOUTTOLUNCH = new System.Windows.Forms.MenuItem();
			this.menuItemSTEPPEDOUT = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItemCUSTOM = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.menuItemINVISIBLE = new System.Windows.Forms.MenuItem();
			this.FriendsTreeView = new System.Windows.Forms.TreeView();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuLogin = new System.Windows.Forms.MenuItem();
			this.menuDisconnect = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuSendIM = new System.Windows.Forms.MenuItem();
			this.menuChangeStatus = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuConfig = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuTerminate = new System.Windows.Forms.MenuItem();
			// 
			// statusBar1
			// 
			this.statusBar1.ContextMenu = this.StatusChangeMenu;
			this.statusBar1.Location = new System.Drawing.Point(0, 343);
			this.statusBar1.Size = new System.Drawing.Size(234, 16);
			this.statusBar1.Text = "OCĂ";
			// 
			// StatusChangeMenu
			// 
			this.StatusChangeMenu.MenuItems.Add(this.menuItemAVAILABLE);
			this.StatusChangeMenu.MenuItems.Add(this.menuItem3);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemBRB);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemBUSY);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemNOTATHOME);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemNOTINOFFICE);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemONPHONE);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemONVACATION);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemOUTTOLUNCH);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemSTEPPEDOUT);
			this.StatusChangeMenu.MenuItems.Add(this.menuItem11);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemCUSTOM);
			this.StatusChangeMenu.MenuItems.Add(this.menuItem13);
			this.StatusChangeMenu.MenuItems.Add(this.menuItemINVISIBLE);
			// 
			// menuItemAVAILABLE
			// 
			this.menuItemAVAILABLE.Text = "gp";
			this.menuItemAVAILABLE.Click += new System.EventHandler(this.menuItemAVAILABLE_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Enabled = false;
			this.menuItem3.Text = "-------------------------";
			// 
			// menuItemBRB
			// 
			this.menuItemBRB.Text = "߂܂";
			this.menuItemBRB.Click += new System.EventHandler(this.menuItemBRB_Click);
			// 
			// menuItemBUSY
			// 
			this.menuItemBUSY.Text = "ܑZ";
			this.menuItemBUSY.Click += new System.EventHandler(this.menuItemBUSY_Click);
			// 
			// menuItemNOTATHOME
			// 
			this.menuItemNOTATHOME.Text = "Ƃɂ܂";
			this.menuItemNOTATHOME.Click += new System.EventHandler(this.menuItemNOTATHOME_Click);
			// 
			// menuItemNOTINOFFICE
			// 
			this.menuItemNOTINOFFICE.Text = "ItBXɂ܂";
			this.menuItemNOTINOFFICE.Click += new System.EventHandler(this.menuItemNOTINOFFICE_Click);
			// 
			// menuItemONPHONE
			// 
			this.menuItemONPHONE.Text = "db";
			this.menuItemONPHONE.Click += new System.EventHandler(this.menuItemONPHONE_Click);
			// 
			// menuItemONVACATION
			// 
			this.menuItemONVACATION.Text = "xɒ";
			this.menuItemONVACATION.Click += new System.EventHandler(this.menuItemONVACATION_Click);
			// 
			// menuItemOUTTOLUNCH
			// 
			this.menuItemOUTTOLUNCH.Text = "H";
			this.menuItemOUTTOLUNCH.Click += new System.EventHandler(this.menuItemOUTTOLUNCH_Click);
			// 
			// menuItemSTEPPEDOUT
			// 
			this.menuItemSTEPPEDOUT.Text = "A";
			this.menuItemSTEPPEDOUT.Click += new System.EventHandler(this.menuItemSTEPPEDOUT_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Enabled = false;
			this.menuItem11.Text = "-------------------------";
			// 
			// menuItemCUSTOM
			// 
			this.menuItemCUSTOM.Text = "ԂJX^}CY";
			this.menuItemCUSTOM.Click += new System.EventHandler(this.menuItemCUSTOM_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Enabled = false;
			this.menuItem13.Text = "-------------------------";
			// 
			// menuItemINVISIBLE
			// 
			this.menuItemINVISIBLE.Enabled = false;
			this.menuItemINVISIBLE.Text = "OCԂB";
			this.menuItemINVISIBLE.Click += new System.EventHandler(this.menuItemINVISIBLE_Click);
			// 
			// FriendsTreeView
			// 
			this.FriendsTreeView.ImageIndex = -1;
			this.FriendsTreeView.Location = new System.Drawing.Point(0, 24);
			this.FriendsTreeView.SelectedImageIndex = -1;
			this.FriendsTreeView.Size = new System.Drawing.Size(234, 314);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.menuItem1);
			// 
			// menuItem1
			// 
			this.menuItem1.MenuItems.Add(this.menuLogin);
			this.menuItem1.MenuItems.Add(this.menuDisconnect);
			this.menuItem1.MenuItems.Add(this.menuItem2);
			this.menuItem1.MenuItems.Add(this.menuSendIM);
			this.menuItem1.MenuItems.Add(this.menuChangeStatus);
			this.menuItem1.MenuItems.Add(this.menuItem4);
			this.menuItem1.MenuItems.Add(this.menuConfig);
			this.menuItem1.MenuItems.Add(this.menuItem5);
			this.menuItem1.MenuItems.Add(this.menuTerminate);
			this.menuItem1.Text = "ʐM(&C)";
			// 
			// menuLogin
			// 
			this.menuLogin.Text = "ڑ(&L)";
			this.menuLogin.Click += new System.EventHandler(this.menuLogin_Click);
			// 
			// menuDisconnect
			// 
			this.menuDisconnect.Enabled = false;
			this.menuDisconnect.Text = "ؒf(&D)";
			this.menuDisconnect.Click += new System.EventHandler(this.menuDisconnect_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Enabled = false;
			this.menuItem2.Text = "-------------------------";
			// 
			// menuSendIM
			// 
			this.menuSendIM.Enabled = false;
			this.menuSendIM.Text = "bZ[WM(&S)";
			this.menuSendIM.Click += new System.EventHandler(this.menuSendIM_Click);
			// 
			// menuChangeStatus
			// 
			this.menuChangeStatus.Enabled = false;
			this.menuChangeStatus.Text = "Ԃ̕ύX(&T)";
			this.menuChangeStatus.Click += new System.EventHandler(this.menuChangeStatus_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Enabled = false;
			this.menuItem4.Text = "-------------------------";
			// 
			// menuConfig
			// 
			this.menuConfig.Enabled = false;
			this.menuConfig.Text = "ݒ(&O)";
			// 
			// menuItem5
			// 
			this.menuItem5.Enabled = false;
			this.menuItem5.Text = "-------------------------";
			// 
			// menuTerminate
			// 
			this.menuTerminate.Text = "I(&X)";
			this.menuTerminate.Click += new System.EventHandler(this.menuTerminate_Click);
			// 
			// MainForm
			// 
			this.ClientSize = new System.Drawing.Size(234, 359);
			this.Controls.Add(this.FriendsTreeView);
			this.Controls.Add(this.statusBar1);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Text = "Messen";

		}
		#endregion

		static void Main() 
		{
			Application.Run(new MainForm());
		}

		#region bZ[WtH[\邽߂̃fQ[g
		class MessageFormEventArgs : EventArgs
		{
			public YahooData yd;
			public string from, msg;
			public int tm, status, utf8;
			public MessageFormEventArgs() {}
			public MessageFormEventArgs(YahooData _yd, string _from, string _msg, int _tm, int _status, int _utf8)
			{
				yd = _yd;
				from = _from;
				msg = _msg;
				tm = _tm;
				status = _status;
				utf8 = _utf8;
			}
		}

		private void ShowIm(Object sender, EventArgs e)
		{
			MessageFormEventArgs mfea = e as MessageFormEventArgs;
			MessageForm frm = list.Search(mfea.from);
			frm.GotIm(mfea.yd, mfea.from, mfea.msg, mfea.tm, mfea.status, mfea.utf8);
			frm.Show();
		}

		private void ShowNotify(Object sender, EventArgs e)
		{
			MessageFormEventArgs mfea = e as MessageFormEventArgs;
			MessageForm frm = list.Search(mfea.from);
			frm.TypingNotify(mfea.yd, mfea.from, mfea.status);
			frm.Show();
		}
		#endregion

		#region treeView\zfQ[g
		class TreeViewInitEventArgs : EventArgs
		{
			public YahooData yd;
			public YahooUserList list;
			public TreeViewInitEventArgs() {}
			public TreeViewInitEventArgs(YahooData _yd, YahooUserList _list)
			{
				yd = _yd;
				list = _list;
			}
		}
		
		private void TreeViewInit(Object sender, EventArgs e)
		{
			TreeViewInitEventArgs tvea = e as TreeViewInitEventArgs;
			FriendsTreeView.Nodes.Clear();
			TreeNode tn = new TreeNode(tvea.yd.name + " " + YahooUtility.GetStatusString((int)YahooStatus.AVAILABLE, ""));
			FriendsTreeView.Nodes.Add(tn);
			for(int i = 0; i < tvea.list.group.Length; i++)
			{
				tn = new TreeNode(tvea.list.group[i].groupname);
				FriendsTreeView.Nodes.Add(tn);
				for(int j = 0; j < tvea.list.group[i].friendname.Length; j++)
				{
					tn = new TreeNode(tvea.list.group[i].friendname[j] + " [ offline ]");
					FriendsTreeView.Nodes[i + 1].Nodes.Add(tn);
				}
			}
			FriendsTreeView.ExpandAll();
		}
		#endregion

		#region ȍԕύXsfQ[g
		class MemberStatusChangeEventArgs : EventArgs
		{
			public YahooData yd;
			public string name, msg;
			public int status;
			public bool busy;
			public MemberStatusChangeEventArgs() {}
			public MemberStatusChangeEventArgs(YahooData _yd, string _name, int _status, string _msg, bool _busy)
			{
				yd = _yd;
				name = _name;
				msg = _msg;
				busy = _busy;
				status = _status;
			}
		}

		private void MemberStatusChange(object sender, EventArgs e)
		{
			MemberStatusChangeEventArgs mscea = e as MemberStatusChangeEventArgs;
			if(mscea.yd.name == mscea.name)
			{
				FriendsTreeView.Nodes[0].Text = mscea.yd.name + " " + YahooUtility.GetStatusString(mscea.status, mscea.msg);
				return ;
			}
			IEnumerator re = FriendsTreeView.Nodes.GetEnumerator();
			re.Reset();
			while(re.MoveNext())
			{
				TreeNode rootnode = (TreeNode)re.Current;
				IEnumerator ie = rootnode.Nodes.GetEnumerator();
				ie.Reset();
				while(ie.MoveNext())
				{
					TreeNode tn = (TreeNode)ie.Current;
					if(tn.Text.IndexOf(mscea.name + " ", 0) == 0)
					{
						tn.Text = mscea.name + " " + YahooUtility.GetStatusString(mscea.status, mscea.msg);
					}
				}
			}
		}
		#endregion

		#region ԕύXsfQ[g
		class MessageEventArgs : EventArgs
		{
			public string msg;
			public MessageEventArgs() {}
			public MessageEventArgs(string m) { msg = m; }
		}

		private void ChangeStatusBar(object sender, EventArgs e)
		{
			statusBar1.Text = (e as MessageEventArgs).msg;
		}
		#endregion

		private void ChangeDisconnectState(object sender, EventArgs e)
		{
			if(yp != null)
				yp.Disconnect();
			person = null;
			FriendsTreeView.Nodes.Clear();
			statusBar1.Text = "OCĂ";
			menuLogin.Enabled = true;
			menuDisconnect.Enabled = false;
			menuSendIM.Enabled = false;
			menuChangeStatus.Enabled = false;
		}

		#region IYahooMessenger̎
		public void LoginResponse(YahooData yd, int status)
		{
			//System.Diagnostics.Debug.WriteLine("Login:" + status.ToString());
			if(status == (int)YahooLoginStatus.OK)
			{
				Utility.EventDispatcher.Invoke(this, new EventHandler(ChangeStatusBar), null, new MessageEventArgs("ڑ -> "));
			}
			else
			{
				Invoke(new EventHandler(ChangeDisconnectState));
				Utility.EventDispatcher.Invoke(this, new EventHandler(ChangeStatusBar), null, new MessageEventArgs("ڑ -> s"));
			}
		}

		public void GotBuddies(YahooData yd, YahooUserList buddies)
		{
			Utility.EventDispatcher.Invoke(this, new EventHandler(TreeViewInit), null, new TreeViewInitEventArgs(yd, buddies));
		}

		public void GotIgnore(YahooData yd, YahooUserList ignore){}

		public void StatusChanged(YahooData yd, string name, int status, string msg, bool busy)
		{
			//System.Diagnostics.Debug.WriteLine(name + "|" + status.ToString() + "|" + msg + "|" + busy.ToString());
			yd.state = status;
			yd.state_msg = msg;
			yd.state_away = busy;
			Utility.EventDispatcher.Invoke(this, new EventHandler(MemberStatusChange), null, new MemberStatusChangeEventArgs(yd, name, status, msg, busy));
		}

		public void SystemMessage(YahooData yd, string msg)
		{
			//System.Diagnostics.Debug.WriteLine("System:" + msg);
			Utility.EventDispatcher.Invoke(this, new EventHandler(ChangeStatusBar), null, new MessageEventArgs(msg));
		}

		public void GotIm(YahooData yd, string from, string msg, int tm, int status, int utf8)
		{
			
			//System.Diagnostics.Debug.WriteLine("MESSAGE:");
			//System.Diagnostics.Debug.WriteLine("FROM : " + from);
			//System.Diagnostics.Debug.WriteLine("{ : " + msg);
			//System.Diagnostics.Debug.WriteLine("tm:" + tm.ToString());
			//System.Diagnostics.Debug.WriteLine("status:" + status.ToString());
			//System.Diagnostics.Debug.WriteLine("utf8:" + utf8.ToString());
			MessageFormEventArgs mfea = new MessageFormEventArgs(yd, from, msg, tm, status, utf8);
			Utility.EventDispatcher.Invoke(this, new EventHandler(ShowIm), null, mfea);
		}

		public void TypingNotify(YahooData yd, string from, int status)
		{
			//System.Diagnostics.Debug.WriteLine(from + "TYPING... |" + status.ToString());
			MessageFormEventArgs mfea = new MessageFormEventArgs(yd, from, "", 0, status, 0);
			Utility.EventDispatcher.Invoke(this, new EventHandler(ShowNotify), null, mfea);
		}

		public void ErrorNotify(string msg)
		{
			//System.Diagnostics.Debug.WriteLine("Error: " + msg);
			Invoke(new EventHandler(ChangeDisconnectState));
		}

		public void SendIm(int status, string friend, string msg)
		{
			//System.Diagnostics.Debug.WriteLine("SendIm: " + status.ToString() + " To :" + friend + " msg :" + msg);
			yp.SendIM(status, friend, msg);
		}
		#endregion

		#region ԕύX
		private void menuItemAVAILABLE_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.AVAILABLE, "", false);
		}

		private void menuItemBRB_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.BRB, "", false);
		}

		private void menuItemBUSY_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.BUSY, "", false);
		}

		private void menuItemNOTATHOME_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.NOTATHOME, "", false);
		}

		private void menuItemNOTINOFFICE_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.NOTINOFFICE, "", false);
		}

		private void menuItemONPHONE_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.ONPHONE, "", false);
		}

		private void menuItemONVACATION_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.ONVACATION, "", false);
		}

		private void menuItemOUTTOLUNCH_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.OUTTOLUNCH, "", false);
		}

		private void menuItemSTEPPEDOUT_Click(object sender, System.EventArgs e)
		{
			yp.ChangeStatus((int)YahooStatus.STEPPEDOUT, "", false);
		}

		private void menuItemCUSTOM_Click(object sender, System.EventArgs e)
		{
			InputStatusForm frm = new InputStatusForm();

			if(person != null)
			{
				frm.SetUserStatus(person.state_msg, person.state_away);
			}

			DialogResult dr = frm.ShowDialog();
			if(dr == DialogResult.OK)
			{
				yp.ChangeStatus((int)YahooStatus.CUSTOM, frm.msg, frm.busy);
			}
		}

		private void menuItemINVISIBLE_Click(object sender, System.EventArgs e)
		{
			// 
		}
		#endregion

		private void FriendsTreeView_Click(object sender, System.EventArgs e)
		{
			if(person == null)
			{
				menuLogin_Click(sender, e); // 삵ȂH
			}
			statusBar1.Text = "OCĂ";
		}

		private void menuLogin_Click(object sender, System.EventArgs e)
		{
			LoginForm frm = new LoginForm();
			DialogResult dr = frm.ShowDialog();
			if(dr == DialogResult.OK)
			{
				yp = new YahooProcess(this);
				person = new YahooData(frm.user, frm.password);
				YahooPacket p = new YahooPacket(0x4c, 0, 0);
				yp.PacketProcess(person, p);
				menuLogin.Enabled = false;
				menuDisconnect.Enabled = true;
				menuSendIM.Enabled = true;
				menuChangeStatus.Enabled = true;
				statusBar1.Text = "ڑs......";
			}
		}

		private void menuSendIM_Click(object sender, System.EventArgs e)
		{
			if(person == null)
			{
				MessageBox.Show("OCĂ");
				return ;
			}

			string s = "";
			if(FriendsTreeView.SelectedNode != null)
			{
				if(FriendsTreeView.SelectedNode.Parent != null)
					s = FriendsTreeView.SelectedNode.Text;
			}
			if(s == "")
			{
				System.Windows.Forms.MessageBox.Show("MIĂ");
				return;
			}
			s = s.Substring(0, s.IndexOf(" "));
			MessageForm frm = list.Search(s);
			frm.SendIm(person.name, s);
			frm.Show();
		}

		private void menuDisconnect_Click(object sender, System.EventArgs e)
		{
			ChangeDisconnectState(null, null);
		}

		private void menuTerminate_Click(object sender, System.EventArgs e)
		{
			ChangeDisconnectState(null, null);
			this.Close();
		}

		private void menuChangeStatus_Click(object sender, System.EventArgs e)
		{
			StatusChangeMenu.Show(this, new System.Drawing.Point(0, 0));
		}



	}
}