using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using YahooMessenger;

namespace MessenForSig3
{
	public class MessageForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox TotextBox;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox ReceivedtextBox;
		private System.Windows.Forms.TextBox SendtextBox;
		private System.Windows.Forms.Button Sendbutton;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Label Fromlabel;
		private System.Windows.Forms.MenuItem menuSend;
		
		private MessageFormList Owner;
		public string friend;
		public MessageForm(MessageFormList owner)
		{
			InitializeComponent();
			Owner = owner;	
		}

		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuSend = new System.Windows.Forms.MenuItem();
			this.label1 = new System.Windows.Forms.Label();
			this.TotextBox = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.Fromlabel = new System.Windows.Forms.Label();
			this.ReceivedtextBox = new System.Windows.Forms.TextBox();
			this.SendtextBox = new System.Windows.Forms.TextBox();
			this.Sendbutton = new System.Windows.Forms.Button();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.Add(this.menuItem1);
			// 
			// menuItem1
			// 
			this.menuItem1.MenuItems.Add(this.menuSend);
			this.menuItem1.Text = "bZ[W";
			// 
			// menuSend
			// 
			this.menuSend.Text = "M(&S)";
			this.menuSend.Click += new System.EventHandler(this.Sendbutton_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 28);
			this.label1.Size = new System.Drawing.Size(24, 16);
			this.label1.Text = "To:";
			// 
			// TotextBox
			// 
			this.TotextBox.Location = new System.Drawing.Point(32, 24);
			this.TotextBox.ReadOnly = true;
			this.TotextBox.Size = new System.Drawing.Size(120, 19);
			this.TotextBox.Text = "???";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(176, 28);
			this.label2.Size = new System.Drawing.Size(40, 16);
			this.label2.Text = "From:";
			// 
			// Fromlabel
			// 
			this.Fromlabel.Location = new System.Drawing.Point(232, 28);
			this.Fromlabel.Size = new System.Drawing.Size(112, 16);
			this.Fromlabel.Text = "somebody";
			// 
			// ReceivedtextBox
			// 
			this.ReceivedtextBox.Location = new System.Drawing.Point(0, 48);
			this.ReceivedtextBox.Multiline = true;
			this.ReceivedtextBox.ReadOnly = true;
			this.ReceivedtextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.ReceivedtextBox.Size = new System.Drawing.Size(368, 176);
			this.ReceivedtextBox.Text = "";
			// 
			// SendtextBox
			// 
			this.SendtextBox.Location = new System.Drawing.Point(0, 224);
			this.SendtextBox.Multiline = true;
			this.SendtextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.SendtextBox.Size = new System.Drawing.Size(304, 40);
			this.SendtextBox.Text = "";
			this.SendtextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.SendtextBox_KeyPress);
			// 
			// Sendbutton
			// 
			this.Sendbutton.Location = new System.Drawing.Point(304, 224);
			this.Sendbutton.Size = new System.Drawing.Size(64, 40);
			this.Sendbutton.Text = "M";
			this.Sendbutton.Click += new System.EventHandler(this.Sendbutton_Click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 271);
			this.statusBar1.Size = new System.Drawing.Size(370, 16);
			// 
			// MessageForm
			// 
			this.ClientSize = new System.Drawing.Size(370, 287);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.Sendbutton);
			this.Controls.Add(this.SendtextBox);
			this.Controls.Add(this.ReceivedtextBox);
			this.Controls.Add(this.Fromlabel);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.TotextBox);
			this.Controls.Add(this.label1);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Text = "To:";
			this.Closed += new System.EventHandler(this.MessageForm_Closed);

		}
		#endregion

		public void GotIm(YahooData yd, string to, string msg, int tm, int status, int utf8)
		{
			friend = to;
			TotextBox.Text = to;
			Fromlabel.Text = yd.name;
			ReceivedtextBox.Text += to + ": " + msg + "\r\n";
			ReceivedtextBox.Select(ReceivedtextBox.Text.Length, 0);
			ReceivedtextBox.ScrollToCaret();
		}

		public void TypingNotify(YahooData yd, string to, int status)
		{
			friend = to;
			TotextBox.Text = to;
			Fromlabel.Text = yd.name;
			if(status == 0)
				statusBar1.Text = "";
			else
				statusBar1.Text = "Now typing ...";
		}

		public void SendIm(string from, string to)
		{
			friend = to;
			TotextBox.Text = to;
			Fromlabel.Text = from;
		}

		private void MessageForm_Closed(object sender, System.EventArgs e)
		{
			Owner.Delete(friend);
		}

		private void Sendbutton_Click(object sender, System.EventArgs e)
		{
			if(SendtextBox.Text == "")
				return;
			Owner.SendIm((int)YahooStatus.OFFLINE, TotextBox.Text, SendtextBox.Text);
			ReceivedtextBox.Text += Fromlabel.Text + ": " + SendtextBox.Text + "\r\n";
			ReceivedtextBox.Select(ReceivedtextBox.Text.Length, 0);
			ReceivedtextBox.ScrollToCaret();
			SendtextBox.Text = "";
		}

		private void SendtextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(true) // ͕ύX\ɂ
			{
				if(e.KeyChar == (char)13)
				{
					e.Handled = true;
					Sendbutton_Click(null, null);
				}
			}
		}
	}

	public class MessageFormList
	{
		private ArrayList list;
		private IYahooMessenger Owner;
		public MessageFormList(IYahooMessenger owner)
		{
			Owner = owner;
			list = new ArrayList();
		}

		public MessageForm Search(string name)
		{
			for(int i = 0; i < list.Count; i++)
			{
				if((list[i] as MessageForm).friend == name)
				{
					return (list[i] as MessageForm);
				}
			}
			MessageForm frm = new MessageForm(this);
			frm.friend = name;
			list.Add(frm);
			return frm;
		}

		public void Delete(string name)
		{
			for(int i = 0; i < list.Count; i++)
			{
				if((list[i] as MessageForm).friend == name)
				{
					list.RemoveAt(i);
					return ;
				}
			}
		}

		public void SendIm(int status, string friend, string msg)
		{
			Owner.SendIm(status, friend, msg);
		}
	}
}
